#include <stdio.h>
#include <unistd.h>
#define COUNTER 10
int main(int argc, char **argv)
{
    printf("--beginning of program\n");

    int counter = 0;
    pid_t pid = fork();
    printf("pid=%d\n", pid);

    if (pid == 0)
    {
        // child process
        int i = 0;
        for (i=0; i < COUNTER; ++i)
        {
	    printf("CHILD process: Here's my PID: %d\n", getpid());
            printf("CHILD process: counter=%d\n", ++counter);	    
        }
    }
    else if (pid > 0)
    {
        // parent process
        int j = 0;
        for (j=0; j < COUNTER; ++j)
        {
            printf("PARENT process: counter=%d\n", ++counter);
        }
    }
    else
    {
        // fork failed
        printf("fork() failed!\n");
        return 1;
    }

    printf("--end of program--\n");

    return 0;
}


